# This function returns the paths for the profile and home directories
use Win32::UserAdmin;

sub GetProfileHome {
    my $server = shift @_;
    my $username = shift @_;
    my $directories = 0;
    Win32::UserAdmin::UserGetAttributes($server, $username, 3, \%user_info);
    @paths = ($user_info{'USER_HOME_DIR'}, $user_info{'USER_PROFILE'});
}

# Get the file name and flags from the command line

$filename = shift @ARGV;

$not_quiet = 1;

if($filename eq "/v") {
    $verbose = 1;
    $filename = shift @ARGV;
} elsif ($filename eq "/q") {
    $not_quiet = 0;
    $filename = shift @ARGV;
}

if($filename eq "/r") {
    $auto_remove = 1;
    $filename = shift @ARGV;
}

# get the default server name
Win32::UserAdmin::GetDomainController('','', $server);

# Open the file conatining the user names and load them into an array
open(USERLIST, $filename) || die "unable to load $filename\n";

print "Retrieving usernames from $filename...\n" if $not_quiet;
while ($username = <USERLIST>) {
    chomp($username);
    @users = (@users,$username);
    print "$username\n" if $verbose;
}

# For each user in the array we call the GetProfileHome function and
# remove their profile and home directories. Finally we delete the
# user from the registry.

REMOVE: foreach $username(@users) {
   if (!$auto_remove) {
       print "Remove the user - $username? [Yy/Nn] : ";
       if (<STDIN> =~/^y/i) {
           foreach $path(GetProfileHome($server, $username)) {
               qx(rmdir /s /q $path);
               print "removing $path\n" if $verbose;
           }

           Win32::UserAdmin::UserDelete($server, $username);
           print "removing $username - manual \n" if $verbose;

           } else {
               next REMOVE;
           }
       } else {
           foreach $path(GetProfileHome($server, $username)) {
               qx(rmdir /s /q $path);
               print "removing $path\n" if $verbose;
           }
           Win32::UserAdmin::UserDelete($server, $username);
           print "removing $username - auto \n" if $verbose;
       }
}
